Package org.eclipse.mat.snapshot.extension

# Interface ITroubleTicketResolver

public interface ITroubleTicketResolver
Interface for a trouble-ticket component resolver. A trouble-ticket component resolver can propose a proper component (e.g. MAT) within a troubleshooting system (e.g. bugzilla) for a specific class or classloader (e.g. org.eclipse.mat.parser.internal.SnapshotImpl). This information is exposed in the Leak suspects reports. It could help the user who generated the report to open a trouble ticket in the proper component, and this is especially helpful when the user is not familiar with the analyzed coding. Implementations of this interface need to be registered using the `org.eclipse.mat.api.ticketResolver` extension point.

## Method Summary

Modifier and Type
Method
Description
`String`
`getTicketSystem()`
Get the trouble tracking system, e.g Bugzilla
`String`
`resolveByClass(IClass clazz, IProgressListener listener)`
Return a proposal for the component (e.g.
`String`
`resolveByClassLoader(IClassLoader classLoader, IProgressListener listener)`
Return a proposal for the component (e.g.

## Method Details

### getTicketSystem

String getTicketSystem()
Get the trouble tracking system, e.g Bugzilla

Returns:
  a String identifying the trouble-ticket system

### resolveByClass

String resolveByClass(IClass clazz, IProgressListener listener) throws SnapshotException
Return a proposal for the component (e.g. the bugzilla product MAT) based on a class.

Parameters:
  `clazz` - the class for which the component should be proposed
  `listener` - a progress listener
Returns:
  a String for the proposed component, or null if no proposal.
Throws:
  `SnapshotException`

### resolveByClassLoader

String resolveByClassLoader(IClassLoader classLoader, IProgressListener listener) throws SnapshotException
Return a proposal for the component (e.g. the bugzilla product MAT) based on a classloader.

Parameters:
  `classLoader` - the class for which the component should be proposed
  `listener` - a progress listener
Returns:
  a String for the proposed component, or null if no proposal.
Throws:
  `SnapshotException`